import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;

public class CollectionTest {

    /**
     * @param args
     */
    public static void main( String[] args )
    {
        // a list of Object. Can hold objects of any class types.
        ArrayList list1 = new ArrayList();

        list1.add( "abc" );
        list1.add( "bcd" );
        list1.add( "xyz" );

        // 20 is automatically converted to an Integer because of
        // auto boxing/unboxing.
        list1.add( 20 );

        // must cast to Integer in order to use Integer methods.
        System.out.println( ((Integer) list1.get( 3 )).intValue() );

        // a list of Integers defined using the Generics syntax.
        ArrayList<Integer> list3 = new ArrayList<Integer>();
        list3.add( 20 );

        // cast is no longer needed.
        System.out.println( list3.get( 0 ).intValue() );

        // iterate through a list
        for( int i = 0; i < list1.size(); ++i )
            System.out.println( list1.get( i ) );

        // a set of String.
        HashSet<String> set1 = new HashSet<String>();
        set1.add( "abc" );
        set1.add( "bcd" );
        set1.add( "xyz" );

        // iterate through a set using Iterator
        Iterator it1 = set1.iterator();
        while( it1.hasNext() )
            System.out.println( it1.next() );

        // we can specify the element type of an Iterator as well
        Iterator<String> it2 = set1.iterator();
        while( it2.hasNext() )
            System.out.println( it2.next() );

        // iterate through a set using for loop (a.k.a. foreach loop)
        for( String s : set1 )
            System.out.println( s );

        // implement a dictionary using Map
        HashMap<String, String> map1 = new HashMap<String, String>();
        map1.put( "hello", "a way of saying greetings" );
        map1.put( "cs202", "a class of oo programming" );
        System.out.println( map1.get( "cs202" ) );
    }

}
